"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var formatMap = {
    commit: '"%H"',
    authorName: '"%an"',
    authorEmail: '"%ae"',
    committerName: '"%cn"',
    committerEmail: '"%ce"',
    authorDate: '"%at000"',
    committerDate: '"%ct000"',
    title: '"%f"'
};
var GitFormatBuilder = /** @class */ (function () {
    function GitFormatBuilder() {
        this.params = [];
    }
    GitFormatBuilder.prototype.withCommit = function (alias) {
        alias = alias || 'commit';
        this.params.push('"' + alias + '":' + formatMap.commit);
        return this;
    };
    GitFormatBuilder.prototype.withAuthorName = function (alias) {
        alias = alias || 'authorName';
        this.params.push('"' + alias + '":' + formatMap.authorName);
        return this;
    };
    GitFormatBuilder.prototype.withAuthorEmail = function (alias) {
        alias = alias || 'authorEmail';
        this.params.push('"' + alias + '":' + formatMap.authorEmail);
        return this;
    };
    GitFormatBuilder.prototype.withAuthorDate = function (alias) {
        alias = alias || 'authorDate';
        this.params.push('"' + alias + '":' + formatMap.authorDate);
        return this;
    };
    GitFormatBuilder.prototype.withCommiterEmail = function (alias) {
        alias = alias || 'committerEmail';
        this.params.push('"' + alias + '":' + formatMap.committerEmail);
        return this;
    };
    GitFormatBuilder.prototype.withCommiterName = function (alias) {
        alias = alias || 'committerName';
        this.params.push('"' + alias + '":' + formatMap.committerName);
        return this;
    };
    GitFormatBuilder.prototype.withCommiterDate = function (alias) {
        alias = alias || 'committerDate';
        this.params.push('"' + alias + '":' + formatMap.committerDate);
        return this;
    };
    GitFormatBuilder.prototype.withTitle = function (alias) {
        alias = alias || 'title';
        this.params.push('"' + alias + '":' + formatMap.title);
        return this;
    };
    GitFormatBuilder.prototype.build = function () {
        if (this.params.length < 1) {
            return '';
        }
        if (this.isWindows()) {
            return '{' + this.params.toString().replace(/"/g, '"""') + '}';
        }
        return '\'{' + this.params.toString() + '}\'';
    };
    GitFormatBuilder.prototype.isWindows = function () {
        return /^win/.test(process.platform);
    };
    return GitFormatBuilder;
}());
exports.GitFormatBuilder = GitFormatBuilder;
//# sourceMappingURL=git-format-builder.js.map