import { IGlobalErrorHandler, IBranchHistory, IContributors, IHandlerParams, IMap, IScm } from "./contracts";
import Logger = require("bunyan");
export declare class Git implements IScm {
    private buildArgs;
    private globalErrorHandler;
    constructor(buildArgs: any, globalErrorHandler: IGlobalErrorHandler);
    detectCommitVersion(handlerParams: IHandlerParams, logger: Logger): Promise<string>;
    getBranchHistory(handlerParams: IHandlerParams, logger: Logger): Promise<IBranchHistory>;
    getCommitsPerFile(handlerParams: IHandlerParams, logger: Logger): Promise<IMap<number[]>>;
    getRepositoryUrl(handlerParams: IHandlerParams, logger: Logger): Promise<string>;
    getRootDirectory(handlerParams: IHandlerParams, logger: Logger): Promise<string>;
    getFiles(handlerParams: IHandlerParams, logger: Logger): Promise<string[]>;
    getContributors(handlerParams: IHandlerParams, logger: Logger): Promise<IContributors>;
    getGitDiffs(refCommit: string, handlerParams: IHandlerParams, logger: Logger): Promise<any>;
    getCommitOnlyHistory(historyLength: number, handlerParams: IHandlerParams, logger: Logger): Promise<string[]>;
    /**
     *
     * @param gitArgs full git command, without the 'git' prefix, e.g. log -n 1
     * @param handlerParams
     * @param log
     */
    private executeGit;
    private parseContributorsOutput;
    getGitPath(): any;
    getBuildArgs(): any;
    private createCommitLogEntry;
    private logJsonParsError;
    private parseBranchHistoryOutput;
    private parseCommitsPerFileOutput;
    private getHistoryLength;
    private fixUnSupportedJsonCharacters;
    private logParse;
    private parseGitDiffs;
}
